diff -u -r linux.clean/drivers/scsi/scsi.h linux.new2/drivers/scsi/scsi.h
--- linux.clean/drivers/scsi/scsi.h	Mon Sep  6 09:03:51 1999
+++ linux.new2/drivers/scsi/scsi.h	Mon Sep  6 09:03:14 1999
@@ -1,13 +1,13 @@
 /*
  *  scsi.h Copyright (C) 1992 Drew Eckhardt 
- *         Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *         Copyright (C) 1993, 1994, 1995, 1998, 1999 Eric Youngdale
  *  generic SCSI package header file by
  *      Initial versions: Drew Eckhardt
  *      Subsequent revisions: Eric Youngdale
  *
  *  <drew@colorado.edu>
  *
- *       Modified by Eric Youngdale eric@aib.com to
+ *       Modified by Eric Youngdale eric@andante.org to
  *       add scatter-gather, multiple outstanding request, and other
  *       enhancements.
  */
@@ -49,6 +49,21 @@
 #endif
 
 /*
+ * Used for debugging the new queueing code.  We want to make sure
+ * that the lock state is consistent with design.  Only do this in
+ * the user space simulator.
+ */
+#define ASSERT_LOCK(_LOCK, _COUNT)
+
+#if defined(CONFIG_SCSI_NEW_QUEUES) && defined(__SMP__) && defined(CONFIG_USER_DEBUG)
+#undef ASSERT_LOCK
+#define ASSERT_LOCK(_LOCK,_COUNT)       \
+        { if( (_LOCK)->lock != _COUNT )   \
+                panic("Lock count inconsistent %s %d\n", __FILE__, __LINE__); \
+                                                                                       }
+#endif
+
+/*
  *  Use these to separate status msg and our bytes
  *
  *  These are set by:
@@ -378,19 +393,38 @@
 extern int  scsi_block_when_processing_errors(Scsi_Device *);
 extern void scsi_sleep(int);
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+/*
+ * Prototypes for functions in scsi_lib.c
+ */
+extern void initialize_merge_fn(Scsi_Device * SDpnt);
+extern void scsi_request_fn(request_queue_t * q);
+#endif
+
 /*
  *  scsi_abort aborts the current command that is executing on host host.
  *  The error code, if non zero is returned in the host byte, otherwise 
  *  DID_ABORT is returned in the hostbyte.
  */
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+extern int scsi_insert_special_cmd (Scsi_Cmnd * SCpnt, int);
+extern int scsi_dispatch_cmd (Scsi_Cmnd * SCpnt);
+#endif
+
 extern void scsi_do_cmd (Scsi_Cmnd *, const void *cmnd ,
 			 void *buffer, unsigned bufflen, 
 			 void (*done)(struct scsi_cmnd *),
 			 int timeout, int retries);
 
 
+extern void scsi_request_fn(request_queue_t * q);
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+extern Scsi_Cmnd * scsi_allocate_device(Scsi_Device *, int);
+#else
 extern Scsi_Cmnd * scsi_allocate_device(struct request **, Scsi_Device *, int);
+#endif
 
 extern Scsi_Cmnd * scsi_request_queueable(struct request *, Scsi_Device *);
 
@@ -421,9 +455,17 @@
     wait_queue_head_t device_wait;/* Used to wait if
                                                       device is busy */
     struct Scsi_Host   * host;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    request_queue_t         request_queue;
+#endif
     volatile unsigned short device_busy;   /* commands actually active on low-level */
-    void              (* scsi_request_fn)(void);  /* Used to jumpstart things after an 
+#ifndef CONFIG_SCSI_NEW_QUEUES
+    void              (* scsi_request_fn)(request_queue_t *);  /* Used to jumpstart things after an 
                                      * ioctl */
+#else
+    int               (* scsi_init_io_fn)(Scsi_Cmnd *); /* Used to initialize
+                                                           new request */
+#endif
     Scsi_Cmnd          * device_queue;    /* queue of SCSI Command structures */
 
 /* public: */
@@ -431,6 +473,11 @@
 
     unsigned int manufacturer;      /* Manufacturer of device, for using 
 				     * vendor-specific cmd's */
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned sector_size;	    /* size in bytes */
+#endif
+
     int attached;                   /* # of high level drivers attached to 
 				     * this */
     int access_count;               /* Count of open channels/mounts */
@@ -468,6 +515,12 @@
     unsigned expecting_cc_ua:1;     /* Expecting a CHECK_CONDITION/UNIT_ATTN
                                      * because we did a bus reset. */
     unsigned device_blocked:1;      /* Device returned QUEUE_FULL. */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    unsigned ten:1;		    /* support ten byte read / write */
+    unsigned remap:1;		    /* support remapping  */
+    unsigned starved:1;             /* unable to process commands because
+                                       host busy */
+#endif
 };
 
 
@@ -619,6 +672,16 @@
     unsigned long      pid;	   /* Process ID, starts at 0 */
 };
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+/*
+ *  Flag bits for the internal_timeout array
+ */
+#define NORMAL_TIMEOUT 0
+#define IN_ABORT  1
+#define IN_RESET  2
+#define IN_RESET2 4
+#define IN_RESET3 8
+#endif
 
 /*
  * Definitions and prototypes used for scsi mid-level queue.
@@ -630,9 +693,18 @@
 extern int scsi_mlqueue_finish(struct Scsi_Host * host, Scsi_Device * device);
 
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+extern Scsi_Cmnd * scsi_end_request(Scsi_Cmnd * SCpnt, int uptodate,
+                                    int sectors);
+
+extern void scsi_io_completion (Scsi_Cmnd *SCpnt, int good_sectors,
+			 int block_sectors);
+#endif
+
 #if defined(MAJOR_NR) && (MAJOR_NR != SCSI_TAPE_MAJOR)
 #include "hosts.h"
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
 static Scsi_Cmnd * end_scsi_request(Scsi_Cmnd * SCpnt, int uptodate, int sectors)
 {
     struct request * req;
@@ -685,7 +757,7 @@
     scsi_release_command(SCpnt);
     return NULL;
 }
-
+#endif
 
 /* This is just like INIT_REQUEST, but we need to be aware of the fact
  * that an interrupt may start another request, so we run this with interrupts
diff -u -r linux.clean/drivers/scsi/scsi_debug.c linux.new2/drivers/scsi/scsi_debug.c
--- linux.clean/drivers/scsi/scsi_debug.c	Mon Sep  6 11:02:50 1999
+++ linux.new2/drivers/scsi/scsi_debug.c	Mon Sep  6 11:03:06 1999
@@ -42,12 +42,14 @@
 #define NR_FAKE_DISKS   3
 #define N_HEAD          32
 #define N_SECTOR        64
-#define DISK_READONLY(TGT)      (1)
+#define DISK_READONLY(TGT)      (0)
 #define DISK_REMOVEABLE(TGT)    (1)
+#define DEVICE_TYPE(TGT) (TGT == 2 ? TYPE_TAPE : TYPE_DISK);
+
 
 /* Do not attempt to use a timer to simulate a real disk with latency */
 /* Only use this in the actual kernel, not in the simulator. */
-/* #define IMMEDIATE */
+#define IMMEDIATE
 
 /* Skip some consistency checking.  Good for benchmarking */
 #define SPEEDY
@@ -66,6 +68,7 @@
 /* Number of jiffies to wait before completing a command */
 #define DISK_SPEED     10
 #define CAPACITY (0x80000)
+#define SIZE(TGT) (TGT == 2 ? 2248 : 512)
 
 static int starts[] = {N_HEAD, N_HEAD * N_SECTOR, 50000, CAPACITY, 0};
 static int npart = 0;
@@ -244,6 +247,10 @@
 	SCpnt->result = 0;
 	done(SCpnt); 
 	return 0;
+    case START_STOP:
+	SCSI_LOG_LLQUEUE(3,printk("START_STOP\n"));
+	scsi_debug_errsts = 0;
+	break;
     case ALLOW_MEDIUM_REMOVAL:
 	if(cmd[4]) 
         {
@@ -258,7 +265,7 @@
     case INQUIRY:
 	SCSI_LOG_LLQUEUE(3,printk("Inquiry...(%p %d)\n", buff, bufflen));
 	memset(buff, 0, bufflen);
-	buff[0] = TYPE_DISK;
+	buff[0] = DEVICE_TYPE(target);
 	buff[1] = DISK_REMOVEABLE(target) ? 0x80 : 0;  /* Removable disk */
 	buff[2] = 1;
 	buff[4] = 33 - 5;
@@ -281,7 +288,10 @@
 	buff[1] = (CAPACITY >> 16) & 0xff;
 	buff[2] = (CAPACITY >> 8) & 0xff;
 	buff[3] = CAPACITY & 0xff;
-	buff[6] = 2; /* 512 byte sectors */
+        buff[4] = 0;
+        buff[5] = 0;
+	buff[6] = (SIZE(target) >> 8) & 0xff; /* 512 byte sectors */
+        buff[7] = SIZE(target) & 0xff;
 	scsi_debug_errsts = 0;
 	break;
     case READ_10:
@@ -465,6 +475,8 @@
     if( !scsi_debug_lockup )
     {
         SCpnt->result = scsi_debug_errsts;
+        SCint[i]   = SCpnt;
+        do_done[i] = done;
         scsi_debug_intr_handle(i);  /* No timer - do this one right away */
     }
     restore_flags(flags);
@@ -691,7 +703,22 @@
 	len = length;
     
     return(len);
+
 }
+#ifdef CONFIG_USER_DEBUG
+/*
+ * This is a hack for the user space emulator.  It allows us to
+ * "insert" arbitrary numbers of additional drivers.
+ */
+void * scsi_debug_get_handle(void)
+{
+     static Scsi_Host_Template driver_copy = SCSI_DEBUG;
+     void * rtn;
+     rtn = kmalloc(sizeof(driver_copy), GFP_ATOMIC);
+     memcpy(rtn, (void *) &driver_copy, sizeof(driver_copy));
+     return rtn;
+}
+#endif
 
 #ifdef MODULE
 /* Eventually this will go into an include file, but this will be later */
diff -u -r linux.clean/drivers/scsi/scsi_debug.h linux.new2/drivers/scsi/scsi_debug.h
--- linux.clean/drivers/scsi/scsi_debug.h	Mon Dec 28 01:19:23 1998
+++ linux.new2/drivers/scsi/scsi_debug.h	Wed Jul 28 19:22:39 1999
@@ -34,9 +34,9 @@
 		    bios_param:        scsi_debug_biosparam,	\
 		    can_queue:         SCSI_DEBUG_CANQUEUE,	\
 		    this_id:           7,			\
-		    sg_tablesize:      SG_ALL,			\
+		    sg_tablesize:      16,			\
 		    cmd_per_lun:       3,			\
-		    unchecked_isa_dma: 1,			\
+		    unchecked_isa_dma: 0,			\
 		    use_clustering:    ENABLE_CLUSTERING,	\
 		    use_new_eh_code:   1,			\
 }
diff -u -r linux.clean/drivers/scsi/scsi_error.c linux.new2/drivers/scsi/scsi_error.c
--- linux.clean/drivers/scsi/scsi_error.c	Wed Jun 16 22:26:27 1999
+++ linux.new2/drivers/scsi/scsi_error.c	Sun Sep  5 09:05:03 1999
@@ -127,7 +127,9 @@
  *
  * Arguments:   SCset   - command that we are canceling timer for.
  *
- * Returns:     Amount of time remaining before command would have timed out.
+ * Returns:     1 if we were able to detach the timer.  0 if we
+ *              blew it, and the timer function has already started
+ *              to run.
  *
  * Notes:	This should be turned into an inline function.
  */
@@ -136,8 +138,12 @@
 {
   int rtn;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
   rtn = jiffies - SCset->eh_timeout.expires;
   del_timer(&SCset->eh_timeout);
+#else
+  rtn = del_timer(&SCset->eh_timeout);
+#endif
 
   SCSI_LOG_ERROR_RECOVERY(5,printk("Clearing timer for command %p\n", SCset));
 
@@ -572,9 +578,13 @@
     
     add_timer(&timer);
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irq(&io_request_lock);
+#endif
     down(&sem);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irq(&io_request_lock);
+#endif
     
     del_timer(&timer);
 }
@@ -844,7 +854,14 @@
    * If we had a successful bus reset, mark the command blocks to expect
    * a condition code of unit attention.
    */
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_unlock_irq(&io_request_lock);
+#endif
   scsi_sleep(BUS_RESET_SETTLE_TIME);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_lock_irq(&io_request_lock);
+#endif
   if( SCpnt->eh_state == SUCCESS )
     {
       Scsi_Device * SDloop;
@@ -893,7 +910,13 @@
      * If we had a successful host reset, mark the command blocks to expect
      * a condition code of unit attention.
      */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_unlock_irq(&io_request_lock);
+#endif
     scsi_sleep(HOST_RESET_SETTLE_TIME);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  spin_lock_irq(&io_request_lock);
+#endif
     if( SCpnt->eh_state == SUCCESS )
     {
         Scsi_Device * SDloop;
@@ -1244,6 +1267,9 @@
 scsi_restart_operations(struct Scsi_Host * host)
 {
   Scsi_Device * SDpnt;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+  unsigned long flags;
+#endif
 
   /*
    * Next free up anything directly waiting upon the host.  This will be
@@ -1254,6 +1280,28 @@
 
    wake_up(&host->host_wait);
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+   /*
+    * Finally we need to re-initiate requests that may be pending.  We will
+    * have had everything blocked while error handling is taking place, and
+    * now that error recovery is done, we will need to ensure that these
+    * requests are started.
+    */
+   spin_lock_irqsave(&io_request_lock, flags);
+   for( SDpnt = host->host_queue; SDpnt; SDpnt = SDpnt->next )
+   {
+       request_queue_t  * q;
+       if(    (host->can_queue > 0 && (host->host_busy >= host->can_queue))
+	    || (host->host_blocked) 
+	    || (SDpnt->device_blocked) )
+       {
+           break;
+       }
+       q = &SDpnt->request_queue;
+       q->request_fn(q);
+   }
+   spin_unlock_irqrestore(&io_request_lock, flags);
+#else
    /*
     * Finally, block devices need an extra kick in the pants.  This is because
     * the request queueing mechanism may have queued lots of pending requests
@@ -1266,8 +1314,9 @@
        SCSI_LOG_ERROR_RECOVERY(5,printk("Calling request function to restart things...\n"));
 
        if( SDpnt->scsi_request_fn != NULL )
-	 (*SDpnt->scsi_request_fn)();
+	 (*SDpnt->scsi_request_fn)(NULL);
      }
+#endif
 }
 
 /*
@@ -1652,7 +1701,13 @@
                        * Due to the spinlock, we will never get out of this
                        * loop without a proper wait (DB)
                        */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+                    spin_unlock_irq(&io_request_lock);
+#endif
                       scsi_sleep(1 * HZ);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+                      spin_lock_irq(&io_request_lock);
+#endif
 
                       goto next_device;
                   }
@@ -1761,7 +1816,13 @@
                 * Due to the spinlock, we will never get out of this
                 * loop without a proper wait. (DB)
                 */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+              spin_unlock_irq(&io_request_lock);
+#endif
                scsi_sleep(1 * HZ);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+               spin_lock_irq(&io_request_lock);
+#endif
 
               goto next_device2;
           }
diff -u -r linux.clean/drivers/scsi/scsi_ioctl.c linux.new2/drivers/scsi/scsi_ioctl.c
--- linux.clean/drivers/scsi/scsi_ioctl.c	Tue May 11 17:37:40 1999
+++ linux.new2/drivers/scsi/scsi_ioctl.c	Wed Jul 28 19:22:39 1999
@@ -19,7 +19,7 @@
 #include <scsi/scsi_ioctl.h>
 
 #define NORMAL_RETRIES 5   
-#define NORMAL_TIMEOUT (10 * HZ)
+#define IOCTL_NORMAL_TIMEOUT (10 * HZ)
 #define FORMAT_UNIT_TIMEOUT (2 * 60 * 60 * HZ)
 #define START_STOP_TIMEOUT (60 * HZ)
 #define MOVE_MEDIUM_TIMEOUT (5 * 60 * HZ)
@@ -67,7 +67,7 @@
 /*
  * 
  * The SCSI_IOCTL_SEND_COMMAND ioctl sends a command out to the SCSI host.
- * The NORMAL_TIMEOUT and NORMAL_RETRIES  variables are used.  
+ * The IOCTL_NORMAL_TIMEOUT and NORMAL_RETRIES  variables are used.  
  * 
  * dev is the SCSI device struct ptr, *(int *) arg is the length of the
  * input data, if any, not including the command string & counts, 
@@ -103,22 +103,34 @@
 static int ioctl_internal_command(Scsi_Device *dev, char * cmd,
 				  int timeout, int retries)
 {
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned long flags;
+#endif
     int result;
     Scsi_Cmnd * SCpnt;
     Scsi_Device * SDpnt;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
 
     SCSI_LOG_IOCTL(1, printk("Trying ioctl with scsi command %d\n", cmd[0]));
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt = scsi_allocate_device(dev, 1);
+#else
     SCpnt = scsi_allocate_device(NULL, dev, 1);
+#endif
     {
 	DECLARE_MUTEX_LOCKED(sem);
 	SCpnt->request.sem = &sem;
 	scsi_do_cmd(SCpnt,  cmd, NULL,  0, scsi_ioctl_done,  timeout, retries);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	down(&sem);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
         SCpnt->request.sem = NULL;
     }
     
@@ -163,11 +175,15 @@
     scsi_release_command(SCpnt);
     SCpnt = NULL;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     if (!SDpnt->was_reset && SDpnt->scsi_request_fn)
-	(*SDpnt->scsi_request_fn)();
+	(*SDpnt->scsi_request_fn)(NULL);
+#endif
 
     wake_up(&SDpnt->device_wait);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
     return result;
 }
 
@@ -178,7 +194,9 @@
  */
 int scsi_ioctl_send_command(Scsi_Device *dev, Scsi_Ioctl_Command *sic)
 {
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned long flags;
+#endif
     char * buf;
     unsigned char cmd[12]; 
     char * cmd_in;
@@ -227,9 +245,13 @@
     if(buf_needed){
 	buf_needed = (buf_needed + 511) & ~511;
 	if (buf_needed > MAX_BUF) buf_needed = MAX_BUF;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buf = (char *) scsi_malloc(buf_needed);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if (!buf) return -ENOMEM;
 	memset(buf, 0, buf_needed);
     } else
@@ -277,23 +299,30 @@
  	retries = NORMAL_RETRIES;
 	break;
       default:
- 	timeout = NORMAL_TIMEOUT;
+ 	timeout = IOCTL_NORMAL_TIMEOUT;
  	retries = NORMAL_RETRIES;
 	break;
       }
 
 #ifndef DEBUG_NO_CMD
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
     
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt = scsi_allocate_device(dev, 1);
+#else
     SCpnt = scsi_allocate_device(NULL, dev, 1);
-
+#endif
     {
 	DECLARE_MUTEX_LOCKED(sem);
 	SCpnt->request.sem = &sem;
 	scsi_do_cmd(SCpnt,  cmd,  buf, needed,  scsi_ioctl_done,
 		    timeout, retries);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	down(&sem);
         SCpnt->request.sem = NULL;
     }
@@ -316,7 +345,9 @@
     }
     result = SCpnt->result;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
 
     wake_up(&SCpnt->device->device_wait);
     SDpnt = SCpnt->device;
@@ -325,10 +356,14 @@
 
     if (buf) scsi_free(buf, buf_needed);
     
+#ifndef CONFIG_SCSI_NEW_QUEUES
     if(SDpnt->scsi_request_fn)
-	(*SDpnt->scsi_request_fn)();
+	(*SDpnt->scsi_request_fn)(NULL);
+#endif
     
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
     return result;
 #else
     {
@@ -414,7 +449,7 @@
 	scsi_cmd[2] = scsi_cmd[3] = scsi_cmd[5] = 0;
 	scsi_cmd[4] = SCSI_REMOVAL_PREVENT;
 	return ioctl_internal_command((Scsi_Device *) dev, scsi_cmd,
-				      NORMAL_TIMEOUT, NORMAL_RETRIES);
+				      IOCTL_NORMAL_TIMEOUT, NORMAL_RETRIES);
 	break;
     case SCSI_IOCTL_DOORUNLOCK:
 	if (!dev->removable || !dev->lockable) return 0;
@@ -423,14 +458,14 @@
 	scsi_cmd[2] = scsi_cmd[3] = scsi_cmd[5] = 0;
 	scsi_cmd[4] = SCSI_REMOVAL_ALLOW;
 	return ioctl_internal_command((Scsi_Device *) dev, scsi_cmd,
-				      NORMAL_TIMEOUT, NORMAL_RETRIES);
+				      IOCTL_NORMAL_TIMEOUT, NORMAL_RETRIES);
     case SCSI_IOCTL_TEST_UNIT_READY:
 	scsi_cmd[0] = TEST_UNIT_READY;
 	scsi_cmd[1] = dev->lun << 5;
 	scsi_cmd[2] = scsi_cmd[3] = scsi_cmd[5] = 0;
 	scsi_cmd[4] = 0;
 	return ioctl_internal_command((Scsi_Device *) dev, scsi_cmd,
-				      NORMAL_TIMEOUT, NORMAL_RETRIES);
+				      IOCTL_NORMAL_TIMEOUT, NORMAL_RETRIES);
 	break;
     case SCSI_IOCTL_START_UNIT:
 	scsi_cmd[0] = START_STOP;
